/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: chip_sil.h 1067 2014-12-24 14:15:10Z ertl-honda $
 */

/*
 *   sil.hΥåװ¸MPCOREѡ
 *
 *  Υ󥯥롼ɥեϡsil.hƬǥ󥯥롼ɤ롥¾Υե
 *  뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥󥯥롼
 *  ɤˡt_stddef.h󥯥롼ɤΤǡ˰¸Ƥ
 *  褤
 */

#ifndef TOPPERS_CHIP_SIL_H
#define TOPPERS_CHIP_SIL_H

/*
 *  ARMǶ̤
 */
#include "arm_gcc/common/core_sil.h"

#ifndef TOPPERS_MACRO_ONLY

#ifdef USE_GIC_CPULOCK

#define SIL_DIC_CPUIF_PMR  (SIL_MPCORE_PMR_BASE + 0x0104)  /* ͥ٥ޥ쥸 */

#if __TARGET_ARCH_ARM == 6
#define SIL_DIC_CPUIF_PMR_OFFSET 0x04
#elif __TARGET_ARCH_ARM == 7
#define SIL_DIC_CPUIF_PMR_OFFSET 0x03
#endif /* __TARGET_ARCH_ARM == 7 */

Inline void
TOPPERS_set_iipm(uint8_t iipm)
{
	*((volatile uint32_t *)SIL_DIC_CPUIF_PMR) = iipm << SIL_DIC_CPUIF_PMR_OFFSET;
}

Inline uint8_t
TOPPERS_get_iipm(void)
{
	return ((uint8_t)(*((volatile uint32_t *)SIL_DIC_CPUIF_PMR) >> SIL_DIC_CPUIF_PMR_OFFSET));
}

/*
 *  ٤Ƥγߤζػ
 */
Inline uint8_t
TOPPERS_disint(void)
{
	uint8_t iipm;
	iipm = TOPPERS_get_iipm();
	TOPPERS_set_iipm(0);
	return iipm;
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC   uint8_t TOPPERS_iipm
#define SIL_LOC_INT() ((void)(TOPPERS_iipm = TOPPERS_disint()))
#define SIL_UNL_INT() (TOPPERS_set_iipm(TOPPERS_iipm))
#endif /* USE_GIC_CPULOCK */

/*
 *  ץåIDμ
 */
Inline void
sil_get_pid(ID *p_prcid)
{
	uint32_t index;

	Asm("mrc p15, 0, %0, c0, c0, 5":"=r"(index));
	*p_prcid = (index & 0x0f) + 1;
}

/*
 *  ԥåѿchip_config.c
 */
extern uint32_t TOPPERS_spn_var;

#ifndef USE_GIC_CPULOCK

/*
 *  ԥåμ
 */
Inline uint32_t
TOPPERS_sil_loc_spn(void)
{
	uint32_t irq_fiq_mask;
	uint32_t locked;
	uint32_t pre_cpsr_c;
	uint32_t dis_cpsr_c;
	ID       prcid;

	sil_get_pid(&prcid);

	/* ƤӽФcpsrbit07ξ */
	Asm("mrs  %0,CPSR" : "=r"(pre_cpsr_c));

	/* ߥå֤ */
	irq_fiq_mask = TOPPERS_disint();

	/* ߥåְܹԸcpsrbit07ξ */
	Asm("mrs  %0,CPSR" : "=r"(dis_cpsr_c));

	while(true) {
		/*
		 * ԥåμ
		 * ץåID񤭹
		 */
		Asm("   mov      r2, %4      \n"
			"\t ldrex    r1, [%1]    \n"
			"\t cmp      r1, #0x00   \n"
			"\t msrne    cpsr_c, %2  \n" /* ƤӽФξ֤ءʳߵġ */
			"\t wfene                \n"
			"\t msrne    cpsr_c, %3  \n" /* ߥå֤ */
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked)
			:"r"(&TOPPERS_spn_var),"r"(pre_cpsr_c),"r"(dis_cpsr_c),"r"(prcid)
			:"r1","r2", "cc");

		if (locked == 0) {
			/* ԥå */
			/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
			Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0));
#elif __TARGET_ARCH_ARM == 7
			Asm("dmb");
#endif /* __TARGET_ARCH_ARM == 7 */
			Asm("":::"memory");
			return irq_fiq_mask;
		}
	}
}

/*
 *  ԥåֵ
 */
Inline void
TOPPERS_sil_unl_spn(uint32_t irq_fiq_mask)
{
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
	Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0));
#elif __TARGET_ARCH_ARM == 7
	Asm("dmb");
#endif /* __TARGET_ARCH_ARM == 7 */
	TOPPERS_spn_var = 0U;
	/* Data Sync Barrier */
#if __TARGET_ARCH_ARM == 6
	Asm("mcr	p15, 0, %0, c7, c10, 4"::"r"(0));
#elif __TARGET_ARCH_ARM == 7
	Asm("dsb");
#endif /* __TARGET_ARCH_ARM == 7 */
	/* ԥåԤΥإ٥Ȥ */
	Asm("sev");

	/* ԥåμξ֤ */
	TOPPERS_set_fiq_irq(irq_fiq_mask);
}

/*
 *  ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_irq_fiq_mask = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_irq_fiq_mask))

#else /* USE_GIC_CPULOCK */

/*
 *  ԥåμ(USE_GIC_CPULOCK)
 */
Inline uint8_t
TOPPERS_sil_loc_spn(void)
{
	uint8_t  iipm;
	uint32_t locked;
	ID       prcid;

	sil_get_pid(&prcid);

	iipm = TOPPERS_get_iipm();

	/* ߥå֤ */
	TOPPERS_set_iipm(0);

	while(true) {
		/*
		 * ԥåμ
		 * ץåID񤭹
		 */
		Asm("   mov      r2, %2      \n"
			"\t ldrex    r1, [%1]    \n"
			"\t cmp      r1, #0x00   \n"
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked)
			:"r"(&TOPPERS_spn_var),"r"(prcid)
			:"r1","r2", "cc");

		if (locked == 0) {
			/* ԥå */
			/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
			Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0));
#elif __TARGET_ARCH_ARM == 7
			Asm("dmb");
#endif /* __TARGET_ARCH_ARM == 7 */
			Asm("":::"memory");
			return iipm;
		}else{
			/* öߤĤˤ */
			TOPPERS_set_iipm(iipm);
			TOPPERS_set_iipm(0);
		}
	}
}

/*
 *  ԥåֵ(USE_GIC_CPULOCK)
 */
Inline void
TOPPERS_sil_unl_spn(uint8_t iipm)
{
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
	Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0));
#elif __TARGET_ARCH_ARM == 7
	Asm("dmb");
#endif /* __TARGET_ARCH_ARM == 7 */
	TOPPERS_spn_var = 0U;
	/* Data Sync Barrier */
#if __TARGET_ARCH_ARM == 6
	Asm("mcr	p15, 0, %0, c7, c10, 4"::"r"(0));
#elif __TARGET_ARCH_ARM == 7
	Asm("dsb");
#endif /* __TARGET_ARCH_ARM == 7 */
	/* ԥåԤΥإ٥Ȥ */
	Asm("sev");

	/* ԥåμξ֤ */
	TOPPERS_set_iipm(iipm);
}

/*
 *  ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_iipm = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_iipm))

#endif /* USE_GIC_CPULOCK */

/*
 *  ԥåζ
 *  ץåԥåƤ˲롥
 */
Inline void
TOPPERS_sil_force_unl_spn(void)
{
	ID prcid;

	sil_get_pid(&prcid);

	if (TOPPERS_spn_var == prcid) {
		TOPPERS_spn_var = 0U;
		/* ԥåԤΥإ٥Ȥ */
		Asm("sev");
	}
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CHIP_SIL_H */
