/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: logtrace_test1.c 63 2009-01-09 00:30:47Z ertl-honda $
 */

/* 
 *		ȥ졼ץץ(1)
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "logtrace_test1.h"
#include "logtrace/trace_config.h"

extern void target_fput_log(char_t c);

/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))

/*
 *  ¹Լ¹Ԥ륿ؤΥåΰ
 */
volatile char_t	message[3];

/*
 *  롼ײ
 */
ulong_t	task_loop;		/* ǤΥ롼ײ */
ulong_t	tex_loop;		/* 㳰롼ǤΥ롼ײ */

/*
 *  ¹Լ¹Ԥ륿
 */
void task(intptr_t exinf)
{
	int_t		tskno = (int_t) exinf;
	char_t		c;

	SVC_PERROR(ena_tex());
	while (1) {
		c = message[tskno-1];
		if (message[tskno-1] != 0) {
			message[tskno-1] = 0;
		}
		switch (c) {
		case 'e':
			syslog(LOG_INFO, "#%d#ext_tsk()", tskno);
			SVC_PERROR(ext_tsk());
			assert(0);
		case 's':
			syslog(LOG_INFO, "#%d#slp_tsk()", tskno);
			SVC_PERROR(slp_tsk());
			break;
		case 'S':
			syslog(LOG_INFO, "#%d#tslp_tsk(10000)", tskno);
			SVC_PERROR(tslp_tsk(10000));
			break;
		case 'd':
			syslog(LOG_INFO, "#%d#dly_tsk(10000)", tskno);
			SVC_PERROR(dly_tsk(10000));
			break;
		case 'y':
			syslog(LOG_INFO, "#%d#dis_tex()", tskno);
			SVC_PERROR(dis_tex());
			break;
		case 'Y':
			syslog(LOG_INFO, "#%d#ena_tex()", tskno);
			SVC_PERROR(ena_tex());
			break;
		case 'M':
			syslog(LOG_INFO, "#%d#mig_tsk(PE1)", tskno);
			SVC_PERROR(mig_tsk(0, 1));
			break;
		case 'm':
			syslog(LOG_INFO, "#%d#mig_tsk(PE2)", tskno);
			SVC_PERROR(mig_tsk(0, 2));
			break;
#ifdef CPUEXC1
		case 'z':
			syslog(LOG_NOTICE, "#%d#raise CPU exception", tskno);
			RAISE_CPU_EXCEPTION;
			break;
		case 'Z':
			SVC_PERROR(loc_cpu());
			syslog(LOG_NOTICE, "#%d#raise CPU exception", tskno);
			RAISE_CPU_EXCEPTION;
			SVC_PERROR(unl_cpu());
			break;
#endif /* CPUEXC1 */
		default:
			break;
		}
	}
}

/*
 *  ¹ԤƼ¹Ԥ륿ѤΥ㳰롼
 */
void tex_routine(TEXPTN texptn, intptr_t exinf)
{
	volatile ulong_t	i;
	int_t	tskno = (int_t) exinf;

	syslog(LOG_NOTICE, "task%d receives exception 0x%04x.", tskno, texptn);
	for (i = 0; i < tex_loop; i++);

	if ((texptn & 0x8000U) != 0U) {
		syslog(LOG_INFO, "#%d#ext_tsk()", tskno);
		SVC_PERROR(ext_tsk());
		assert(0);
	}
}

/*
 *  CPU㳰ϥɥ
 */
#ifdef CPUEXC1

void
cpuexc_handler(void *p_excinf)
{
	ID		tskid;

	syslog(LOG_NOTICE, "CPU exception handler (p_excinf = %08p).", p_excinf);
	if (sns_ctx() != true) {
		syslog(LOG_WARNING,
					"sns_ctx() is not true in CPU exception handler.");
	}
	if (sns_dpn() != true) {
		syslog(LOG_WARNING,
					"sns_dpn() is not true in CPU exception handler.");
	}
	syslog(LOG_INFO, "sns_loc = %d sns_dsp = %d sns_tex = %d",
									sns_loc(), sns_dsp(), sns_tex());
	syslog(LOG_INFO, "xsns_dpn = %d xsns_xpn = %d",
									xsns_dpn(p_excinf), xsns_xpn(p_excinf));

	if (xsns_xpn(p_excinf)) {
		syslog(LOG_NOTICE, "Sample program ends with exception.");
		SVC_PERROR(ext_ker());
		assert(0);
	}

	SVC_PERROR(iget_tid(&tskid));
	SVC_PERROR(iras_tex(tskid, 0x8000U));
}

#endif /* CPUEXC1 */

/*
 *  ϥɥ
 *
 *  HIGH_PRIORITYMID_PRIORITYLOW_PRIORITY γͥ٤Υǥ塼
 *  ž롥
 */
void cyclic_handler(intptr_t exinf)
{
	SVC_PERROR(irot_rdq(HIGH_PRIORITY));
	SVC_PERROR(irot_rdq(MID_PRIORITY));
	SVC_PERROR(irot_rdq(LOW_PRIORITY));
}

/*
 *  顼ϥɥ
 *
 *  HIGH_PRIORITYMID_PRIORITYLOW_PRIORITY γͥ٤Υǥ塼
 *  ž롥
 */
void alarm_handler(intptr_t exinf)
{
	SVC_PERROR(irot_rdq(HIGH_PRIORITY));
	SVC_PERROR(irot_rdq(MID_PRIORITY));
	SVC_PERROR(irot_rdq(LOW_PRIORITY));
}

/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	ER_UINT	ercd; 

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	/*
	 *  ꥢݡȤν
	 *
	 *  ƥƱꥢݡȤȤʤɡꥢ
	 *  ݡȤץѤߤξˤϤE_OBJ顼ˤʤ뤬پ
	 *  ʤ
	 */
	ercd = serial_opn_por(TASK_PORTID_PRC1);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID_PRC1,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	/*
	 *  εư
	 */
	SVC_PERROR(act_tsk(TASK1));
	SVC_PERROR(act_tsk(TASK2));
	SVC_PERROR(act_tsk(TASK3));

	dly_tsk(10);
	rot_rdq(MID_PRIORITY); /* TASK2 ڤؤ */
	dly_tsk(10);
	rot_rdq(MID_PRIORITY); /* TASK3 ڤؤ */
	dly_tsk(10);
	rot_rdq(MID_PRIORITY); /* TASK1 ڤؤ */

	dly_tsk(10);
	message[0] = 's';  /* TASK1 Ԥ֤ */
	dly_tsk(10);
	message[1] = 's';  /* TASK2 Ԥ֤ */
	dly_tsk(10);
	message[2] = 's';  /* TASK3 Ԥ֤ */

	dly_tsk(10);
	wup_tsk(TASK1);    /* TASK1 ¹Բǽ֤ */
	wup_tsk(TASK2);    /* TASK2 ¹Բǽ֤ */
	wup_tsk(TASK3);    /* TASK3 ¹Բǽ֤ */

	dly_tsk(10);
	mig_tsk(TASK1, 2); /* TASK1 PE2إޥ졼 */
	dly_tsk(10);
	mig_tsk(TASK2, 2); /* TASK2 PE2إޥ졼 */
	dly_tsk(10);
	mig_tsk(TASK3, 2); /* TASK3 PE2إޥ졼 */

	dly_tsk(10);
	message[0] = 'M';  /* TASK1 PE1إޥ졼 */
	dly_tsk(10);
	message[1] = 'M';  /* TASK2 PE1إޥ졼 */  
	dly_tsk(10);
	message[2] = 'M';  /* TASK3 PE1إޥ졼 */  

	dly_tsk(10);
	message[0] = 'e';  /* TASK1 λ */
	dly_tsk(10);
	message[1] = 'e';  /* TASK2 λ */
	dly_tsk(10);
	message[2] = 'e';  /* TASK3 λ */

	/*
	 *  ϥɥεư
	 */
	sta_cyc(CYCHDR1);

	dly_tsk(50);

	msta_cyc(CYCHDR1, 2); /* PE2إޥ졼 */

	dly_tsk(50);

	msta_cyc(CYCHDR1, 1); /* PE1إޥ졼 */

	dly_tsk(50);

	stp_cyc(CYCHDR1);

	/*
	 *  顼ϥɥεư
	 */
	sta_alm(ALMHDR1, 10);

	dly_tsk(20);

	msta_alm(ALMHDR1, 10, 2); /* PE2إޥ졼 */

	dly_tsk(20);

	msta_alm(ALMHDR1, 10, 1); /* PE1إޥ졼 */

	dly_tsk(20);

	ext_ker();
}
